use 5.38.0;

use Test2::V0;

use Path::Tiny;
use File::Serialize;

use Part2;

my $input = path('input')->slurp;
my $example   = path('example')->slurp;
my %solutions = deserialize_file('solutions.yml')->%*;

is Part2::solution_2(<<'END') => 6;
LR

11A = (11B, XXX)
11B = (XXX, 11Z)
11Z = (11B, XXX)
22A = (22B, XXX)
22B = (22C, 22C)
22C = (22Z, 22Z)
22Z = (22B, 22B)
XXX = (XXX, XXX)
END

is Part2::solution_2($input) => $solutions{2};

done_testing;
